NewsFeed/NewsFeed.Web/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using NewsFeed.Domain;
using NewsFeed.Web.Models;

namespace NewsFeed.Web.Controllers
{
    public class HomeController : Controller
    {
        private readonly IUnitOfWork unitOfWork;

        public HomeController(IUnitOfWork unitOfWork)
        {
            this.unitOfWork = unitOfWork;
        }

        public async Task<IActionResult> Index()
        {
            try
            {
                var model = await unitOfWork.NewsRepository.ListAsync();
                return View(model);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

NewsFeed/NewsFeed.Web/Controllers/NewsController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using NewsFeed.Domain;
using NewsFeed.Domain.DTO;
using Microsoft.AspNetCore.Identity;

namespace NewsFeed.Web.Controllers
{
    public class NewsController : Controller
    {
        private readonly IUnitOfWork unitOfWork;
        private readonly UserManager<IdentityUser> _userManager;

        public NewsController(IUnitOfWork unitOfWork, UserManager<IdentityUser> userManager)
        {
            this.unitOfWork = unitOfWork;
            _userManager = userManager;
        }

        public async Task<IEnumerable<NewsCategoryDTO>> GetNewsCategories()
        {
            return await unitOfWork.NewsCategoryRepository.ListAsync();
        }

        public async Task<IEnumerable<NewsDTO>> GetNews()
        {
            return await unitOfWork.NewsRepository.ListAsync();
        }

        // GET: News
        public async Task<ActionResult> Index()
        {
            try
            {
                var userId =  await GetUserId();
                var newsList = await GetNews();
                var categories = await GetNewsCategories();

                var model = newsList.Where(u => u.UserCreated == userId);

                var list = from nw in model
                           join cat in categories on nw.NewsCategory equals cat.CategoryId
                           select new NewsDTO
                           {
                               NewsId = nw.NewsId,
                               NewTitle = nw.NewTitle,
                               NewDescription = nw.NewDescription,
                               NewsCategory = nw.NewsCategory,
                               NewsCategoryName = cat.CategoryName,
                               UserCreated = nw.UserCreated,
                               UsersSubscribed = nw.UsersSubscribed
                           };

                ViewBag.Subscriptions = list.Where(m => m.UsersSubscribed != null).Select(m => m.UsersSubscribed).ToString().Split(",").Count();
                return View(list);
            }
            catch(Exception ex)
            {
                throw ex;
            }

        }

        public async Task<IEnumerable<FeedsUserDTO>> GetFeedUsers()
        {
            return await unitOfWork.UserFeedRepository.ListAsync();
        }

        // GET: News/Details/5
        public async Task<ActionResult> Details(int id)
        {
            try
            {
                var news = await unitOfWork.NewsRepository.FindByIdAsync(id);
                var users = await GetFeedUsers();
                ViewBag.createdBy = users.Where(u => u.UserId == news.UserCreated).Select(u => u.FirstName).Single();
                if (news != null)
                {
                    return View(news);
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return View();
        }

        public JsonResult GetCategories(string term, string page)
        {
            var result = unitOfWork.NewsCategoryRepository.FindByName(term).Select(cat => new { id = cat.CategoryId, text = cat.CategoryName }).ToList();
            return Json(result);
        }

        // GET: News/Create
        public ActionResult Create()
        {
            List<NewsCategoryDTO> newsCategories = new List<NewsCategoryDTO>();
            newsCategories = (from cat in unitOfWork.NewsCategoryRepository.List()
                              select cat).ToList();

            ViewBag.CategoryList = newsCategories;
            return View();
        }

        // POST: News/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Create(NewsDTO news)
        {
            try
            {                
                news.UserCreated = await GetUserId();
                unitOfWork.NewsRepository.Add(news);
                await unitOfWork.SaveChangesAsync();

                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: News/Edit/5
        public ActionResult Edit(int id)
        {
            var model = unitOfWork.NewsRepository.FindById(id);
            List<NewsCategoryDTO> newsCategories = new List<NewsCategoryDTO>();
            newsCategories = (from cat in unitOfWork.NewsCategoryRepository.List()
                              select cat).ToList();

            ViewBag.CategoryList = newsCategories;
            return View(model);
        }

        // POST: News/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Edit(int id, NewsDTO news)
        {
            try
            {
                news.UserCreated = await GetUserId();
                unitOfWork.NewsRepository.Update(news);
                await unitOfWork.SaveChangesAsync();

                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: News/Delete/5
        public ActionResult Delete(int id)
        {
            var model = unitOfWork.NewsRepository.FindById(id);
            return View(model);
        }

        // POST: News/Delete/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Delete(int id, NewsDTO news)
        {
            try
            {
                unitOfWork.NewsRepository.Remove(id);
                await unitOfWork.SaveChangesAsync();

                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        public async Task<int> GetUserId()
        {
            var userIdentity = _userManager.GetUserId(User);
            var userId = await unitOfWork.UserFeedRepository.FindByUserId(userIdentity);
            return userId.UserId;
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Subscribe(int id)
        {
            try
            {
                var subscriptor = $"{_userManager.GetUserName(User)},";
                unitOfWork.NewsRepository.Subscribe(id, subscriptor);
                await unitOfWork.SaveChangesAsync();

                return RedirectToAction("Index", "Home"); 
            }
            catch
            {
                return RedirectToAction("Index", "Home");
            }
        }
    }
}

NewsFeed/NewsFeed.Web/Views/Home/About.cshtml
@{
    ViewData["Title"] = "About";
}
<h2>@ViewData["Title"]</h2>
<h3>@ViewData["Message"]</h3>

<p>Use this area to provide additional information.</p>

NewsFeed/NewsFeed.Web/Views/Home/Contact.cshtml
@{
    ViewData["Title"] = "Contact";
}
<h2>@ViewData["Title"]</h2>
<h3>@ViewData["Message"]</h3>

<address>
    One Microsoft Way<br />
    Redmond, WA 98052-6399<br />
    <abbr title="Phone">P:</abbr>
    425.555.0100
</address>

<address>
    <strong>Support:</strong> <a href="mailto:Support@example.com">Support@example.com</a><br />
    <strong>Marketing:</strong> <a href="mailto:Marketing@example.com">Marketing@example.com</a>
</address>

NewsFeed/NewsFeed.Web/Views/Home/Index.cshtml
@model IEnumerable<NewsFeed.Domain.DTO.NewsDTO>
@using Microsoft.AspNetCore.Identity

@inject SignInManager<IdentityUser> SignInManager
@inject UserManager<IdentityUser> UserManager
@{
    ViewData["Title"] = "Home Page";
}

@if (SignInManager.IsSignedIn(User))
{
    <div class="jumbotron">
        <h1>Modus Create News</h1>
        <p>Latest News</p>
    </div>
} else
{
    <div class="jumbotron">
        <h1>Modus Create News</h1>
        <p>Here you can learn and publish notices</p>
        <div class="row">
            <p>
                <a asp-area="Identity" asp-page="/Account/Register" class="btn btn-success btn-lg col-md-2" style="margin: 0px 9px 9px 0px;">Register </a>
                
                <a asp-area="Identity" asp-page="/Account/Login" class="btn btn-success btn-lg col-md-2">Login</a>
            </p>
            
        </div>       
    </div>
}




<div class="row">
    @if (SignInManager.IsSignedIn(User))
    {
        @foreach (var item in Model)
        {
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>@Html.DisplayFor(modelItem => item.NewTitle)</h3>
                        <p>@Html.DisplayFor(modelItem => item.NewDescription)</p>
                        <p>
                            @Html.ActionLink("Read More", "Details", "News", new { id = item.NewsId }, new { @role = "button", @class = "btn btn-default" })
                        </p>
                        <form asp-action="Subscribe" asp-controller="News" asp-route-id="@item.NewsId">
                            <input type="submit" value="Subscribe" class="btn btn-primary" />
                            @Html.HiddenFor(modelItem => item.NewsId)
                        </form>
                    </div>
                </div>
            </div>
        }
    }
    else
    {

    }

</div>